# Contributing to PygameCommunityBot

- First of all, all contributors are expected to follow the [code of conduct](CODE_OF_CONDUCT.md).
- Any contributor to the PygameCommunityBot must be a member of our discord server.
- To contribute to the bot repo, feel free to open a PR on Github. The collaborators will review
 your changes, make suggestions and merge it in when they are happy with it.
- To make any substantial changes to the bot, it is better to first discuss it with us on discord.
- All issues or feature requests related to this repo are managed on discord, do not use use
 the github issues section for this purpose.
 
## Code Quality
- We expect contributors to write clean code. Because code is more often read than written.
- For code quality consistence, we use a tool called black, and we expect contributors to
 run black on the code they are contributing, to make the code formatting more consistent.
- To run black, simply run the `cleancode.py` file, this will black format all files.

## Testing bot changes and discord roles
- We realise that testing new bot features you want to add can be a bit of a daunting task, so once
 you have made a few contributions to the bot, you will get a `@Sorcerer 🝐` role on our discord server,
 and access to the bot token of a "test bot", which you can use to run a local version of the bot
 yourself, to test and debug things out.
- You will also have access to the `🤖 Bot Dev` channels, to discuss with other bot devs, test out your
 changes and raise issues or make feature requests.
- Further contributions will help you get the `@Wizard 🝑` role, with access to "admin" commands of the
 bot, and then finally, a `@Senior Mage 🝒` role when you have made substantial improvements to the bot.